// **********************************************************************
//
// Copyright (c) 2003-2011 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.4.2
//
// <auto-generated>
//
// Generated from file `Current.java'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package Ice;

/**
 * Information about the current method invocation for servers. Each
 * operation on the server has a <tt>Current</tt> as its implicit final
 * parameter. <tt>Current</tt> is mostly used for Ice services. Most
 * applications ignore this parameter.
 * 
 **/
public class Current implements java.lang.Cloneable
{
    /**
     * The object adapter.
     * 
     **/
    public ObjectAdapter adapter;

    /**
     * Information about the connection over which the current method
     * invocation was received. If the invocation is direct due to
     * collocation optimization, this value is set to null.
     * 
     **/
    public Connection con;

    /**
     * The Ice object identity.
     * 
     **/
    public Identity id;

    /**
     * The facet.
     * 
     **/
    public String facet;

    /**
     * The operation name.
     * 
     **/
    public String operation;

    /**
     * The mode of the operation.
     * 
     **/
    public OperationMode mode;

    /**
     * The request context, as received from the client.
     * 
     **/
    public java.util.Map<java.lang.String, java.lang.String> ctx;

    /**
     * The request id unless oneway (0) or collocated (-1).
     * 
     **/
    public int requestId;

    public Current()
    {
    }

    public Current(ObjectAdapter adapter, Connection con, Identity id, String facet, String operation, OperationMode mode, java.util.Map<java.lang.String, java.lang.String> ctx, int requestId)
    {
        this.adapter = adapter;
        this.con = con;
        this.id = id;
        this.facet = facet;
        this.operation = operation;
        this.mode = mode;
        this.ctx = ctx;
        this.requestId = requestId;
    }

    public boolean
    equals(java.lang.Object rhs)
    {
        if(this == rhs)
        {
            return true;
        }
        Current _r = null;
        try
        {
            _r = (Current)rhs;
        }
        catch(ClassCastException ex)
        {
        }

        if(_r != null)
        {
            if(adapter != _r.adapter)
            {
                if(adapter == null || _r.adapter == null || !adapter.equals(_r.adapter))
                {
                    return false;
                }
            }
            if(con != _r.con)
            {
                if(con == null || _r.con == null || !con.equals(_r.con))
                {
                    return false;
                }
            }
            if(id != _r.id)
            {
                if(id == null || _r.id == null || !id.equals(_r.id))
                {
                    return false;
                }
            }
            if(facet != _r.facet)
            {
                if(facet == null || _r.facet == null || !facet.equals(_r.facet))
                {
                    return false;
                }
            }
            if(operation != _r.operation)
            {
                if(operation == null || _r.operation == null || !operation.equals(_r.operation))
                {
                    return false;
                }
            }
            if(mode != _r.mode)
            {
                if(mode == null || _r.mode == null || !mode.equals(_r.mode))
                {
                    return false;
                }
            }
            if(ctx != _r.ctx)
            {
                if(ctx == null || _r.ctx == null || !ctx.equals(_r.ctx))
                {
                    return false;
                }
            }
            if(requestId != _r.requestId)
            {
                return false;
            }

            return true;
        }

        return false;
    }

    public int
    hashCode()
    {
        int __h = 0;
        if(adapter != null)
        {
            __h = 5 * __h + adapter.hashCode();
        }
        if(con != null)
        {
            __h = 5 * __h + con.hashCode();
        }
        if(id != null)
        {
            __h = 5 * __h + id.hashCode();
        }
        if(facet != null)
        {
            __h = 5 * __h + facet.hashCode();
        }
        if(operation != null)
        {
            __h = 5 * __h + operation.hashCode();
        }
        if(mode != null)
        {
            __h = 5 * __h + mode.hashCode();
        }
        if(ctx != null)
        {
            __h = 5 * __h + ctx.hashCode();
        }
        __h = 5 * __h + requestId;
        return __h;
    }

    public java.lang.Object
    clone()
    {
        java.lang.Object o = null;
        try
        {
            o = super.clone();
        }
        catch(CloneNotSupportedException ex)
        {
            assert false; // impossible
        }
        return o;
    }
}
