// **********************************************************************
//
// Copyright (c) 2003-2011 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.4.2
//
// <auto-generated>
//
// Generated from file `ServerInfo.java'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package IceGrid;

/**
 * Information about a server managed by an IceGrid node.
 * 
 **/
public class ServerInfo implements java.lang.Cloneable, java.io.Serializable
{
    /**
     * The server application. 
     * 
     **/
    public String application;

    /**
     * The application uuid.
     * 
     **/
    public String uuid;

    /**
     * The application revision.
     * 
     **/
    public int revision;

    /**
     * The server node. 
     * 
     **/
    public String node;

    /**
     * The server descriptor. 
     * 
     **/
    public ServerDescriptor descriptor;

    /**
     * The id of the session which allocated the server.
     * 
     **/
    public String sessionId;

    public ServerInfo()
    {
    }

    public ServerInfo(String application, String uuid, int revision, String node, ServerDescriptor descriptor, String sessionId)
    {
        this.application = application;
        this.uuid = uuid;
        this.revision = revision;
        this.node = node;
        this.descriptor = descriptor;
        this.sessionId = sessionId;
    }

    public boolean
    equals(java.lang.Object rhs)
    {
        if(this == rhs)
        {
            return true;
        }
        ServerInfo _r = null;
        try
        {
            _r = (ServerInfo)rhs;
        }
        catch(ClassCastException ex)
        {
        }

        if(_r != null)
        {
            if(application != _r.application)
            {
                if(application == null || _r.application == null || !application.equals(_r.application))
                {
                    return false;
                }
            }
            if(uuid != _r.uuid)
            {
                if(uuid == null || _r.uuid == null || !uuid.equals(_r.uuid))
                {
                    return false;
                }
            }
            if(revision != _r.revision)
            {
                return false;
            }
            if(node != _r.node)
            {
                if(node == null || _r.node == null || !node.equals(_r.node))
                {
                    return false;
                }
            }
            if(descriptor != _r.descriptor)
            {
                if(descriptor == null || _r.descriptor == null || !descriptor.equals(_r.descriptor))
                {
                    return false;
                }
            }
            if(sessionId != _r.sessionId)
            {
                if(sessionId == null || _r.sessionId == null || !sessionId.equals(_r.sessionId))
                {
                    return false;
                }
            }

            return true;
        }

        return false;
    }

    public int
    hashCode()
    {
        int __h = 0;
        if(application != null)
        {
            __h = 5 * __h + application.hashCode();
        }
        if(uuid != null)
        {
            __h = 5 * __h + uuid.hashCode();
        }
        __h = 5 * __h + revision;
        if(node != null)
        {
            __h = 5 * __h + node.hashCode();
        }
        if(descriptor != null)
        {
            __h = 5 * __h + descriptor.hashCode();
        }
        if(sessionId != null)
        {
            __h = 5 * __h + sessionId.hashCode();
        }
        return __h;
    }

    public java.lang.Object
    clone()
    {
        java.lang.Object o = null;
        try
        {
            o = super.clone();
        }
        catch(CloneNotSupportedException ex)
        {
            assert false; // impossible
        }
        return o;
    }

    public void
    __write(IceInternal.BasicStream __os)
    {
        __os.writeString(application);
        __os.writeString(uuid);
        __os.writeInt(revision);
        __os.writeString(node);
        __os.writeObject(descriptor);
        __os.writeString(sessionId);
    }

    private class Patcher implements IceInternal.Patcher
    {
        public void
        patch(Ice.Object v)
        {
            try
            {
                descriptor = (ServerDescriptor)v;
            }
            catch(ClassCastException ex)
            {
                IceInternal.Ex.throwUOE(type(), v.ice_id());
            }
        }

        public String
        type()
        {
            return "::IceGrid::ServerDescriptor";
        }
    }

    public void
    __read(IceInternal.BasicStream __is)
    {
        application = __is.readString();
        uuid = __is.readString();
        revision = __is.readInt();
        node = __is.readString();
        __is.readObject(new Patcher());
        sessionId = __is.readString();
    }
}
